Subject: [PATCH v2 0/1] Teach the builtin rebase about the builtin interactive rebase

From: "Johannes Schindelin via GitGitGadget" <[email-masked]>
Date: Wed, 29 Aug 2018 07:31:15 -0700 (PDT)

The builtin rebase and the builtin interactive rebase have been developed
independently, on purpose: Google Summer of Code rules specifically state
that students have to work on independent projects, they cannot collaborate
on the same project.

The reason is probably the very fine tradition in academia to prohibit
teamwork, which makes grading easier (at the expense of not exactly
preparing the students for the real world, unless they want to stay in
academia).

One fallout is that the rebase-in-c and rebase-i-in-c patches cause no merge
conflicts but a royal number of tests in the test suite to fail.

It is easy to explain why: rebase-in-c was developed under the assumption
that all rebase backends are implemented in Unix shell script and can be
sourced via . git-rebase--<backend>, which is no longer true with 
rebase-i-in-c, where git-rebase--interactive is a hard-linked builtin.

This patch fixes that.

Note: while this patch targets pk/rebase-in-c-6-final, it will not work
correctly without ag/rebase-i-in-c. So my suggestion is to rewrite the 
pk/rebas-in-c-6-final branch by first merging ag/rebase-i-in-c, then
applying this here patch, and only then cherry-pick "rebase: default to
using the builtin rebase".

Changes since v1:

 * replaced the too-terse commit message by a copy-edited version of this
   cover letter (leaving out only the rant about disallowing teamwork).

Johannes Schindelin (1):
  builtin rebase: prepare for builtin rebase -i

 builtin/rebase.c | 81 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 81 insertions(+)

base-commit: ae497a044508ebaac1794dcdd7ad04f8685686b2
Published-As: https://github.com/gitgitgadget/git/releases/tags/pr-23%2Fdscho%2Frebase-in-c-6-final-v2
Fetch-It-Via: git fetch https://github.com/gitgitgadget/git pr-23/dscho/rebase-in-c-6-final-v2
Pull-Request: https://github.com/gitgitgadget/git/pull/23

Range-diff vs v1:

 1:  29d49819fa ! 1:  5403014be7 builtin rebase: prepare for builtin rebase -i
     @@ -2,8 +2,21 @@
      
          builtin rebase: prepare for builtin rebase -i
      
     -    It is no longer a shell script, so we need to call it in a different way
     -    than the other backends.
     +    The builtin rebase and the builtin interactive rebase have been
     +    developed independently, on purpose: Google Summer of Code rules
     +    specifically state that students have to work on independent projects,
     +    they cannot collaborate on the same project.
     +
     +    One fallout is that the rebase-in-c and rebase-i-in-c patches cause no
     +    merge conflicts but a royal number of tests in the test suite to fail.
     +
     +    It is easy to explain why: rebase-in-c was developed under the
     +    assumption that all rebase backends are implemented in Unix shell script
     +    and can be sourced via `. git-rebase--<backend>`, which is no longer
     +    true with rebase-i-in-c, where git-rebase--interactive is a hard-linked
     +    builtin.
     +
     +    This patch fixes that.
      
          Signed-off-by: Johannes Schindelin <[email-masked]>

-- 
gitgitgadget